package ru.landgrafhomyak.db.sql_skeleton_0.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.DebugApi

public interface Namespace<mUE : Any, RUNTIME_KEY : Any> {
	@DebugApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getName")
	public val name: String

	@DebugApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getPath")
	public val path: List<String>

	@DebugApi
	public val module: Module<mUE, RUNTIME_KEY>
}