package ru.landgrafhomyak.db.sql_skeleton_0.api.runtime

import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries._Statement

public interface Transaction {
	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeQuery(compiledQuery: _Statement.Void2Table<QueryUserExtension>): OutputRow._Iterator<QueryUserExtension, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeQuery(compiledQuery: _Statement.Params2Table<QueryUserExtension>): InputRow._Scope<QueryUserExtension, OutputRow._Iterator<QueryUserExtension, Unit>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeQuery(compiledQuery: _Statement.Table2Void<QueryUserExtension>): InputRow._Iterator<QueryUserExtension, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeQuery(compiledQuery: _Statement.Params2Void<QueryUserExtension>): InputRow._Scope<QueryUserExtension, Unit>

	public suspend fun rollback()

	public suspend fun commit()

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _assertTransactionFinishedAndReleaseResources()
}