package ru.landgrafhomyak.db.sql_skeleton_0.api.misc

import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DriverType


public interface DatabaseType<@Suppress("unused") RUNTIME_TYPE : Any?> {
	public fun interface ImplementationsProvider<RUNTIME_TYPE> {
		public fun provideStatementImplementations_databaseType(scope: Scope<RUNTIME_TYPE>)

		public interface Scope<RUNTIME_TYPE> {
			@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER")
			public fun <DATABASE_TYPE, DATABASE_TYPE_UNBOUND> bind(
				key: DriverType<DATABASE_TYPE_UNBOUND, *, *, *, *, *, *, *, *>, type: DATABASE_TYPE
			) where DATABASE_TYPE_UNBOUND : DatabaseType<*>,
					DATABASE_TYPE : DatabaseType<RUNTIME_TYPE>,
					DATABASE_TYPE : DATABASE_TYPE_UNBOUND
		}
	}
}
