package ru.landgrafhomyak.db.sql_skeleton_0.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.module.Module
import ru.landgrafhomyak.db.sql_skeleton_0.api.module.ModuleTemplate

@LowLevelApi
public interface DatabaseConnection {
	@Suppress("FunctionName")
	@LowLevelApi
	public fun <UE : Any> _createModuleTemplates(x: ModuleTemplate.VersionsInitializer<UE>): UE

	@Suppress("FunctionName")
	@LowLevelApi
	public fun <mUE : Any> _setRootModuleAndLockSchema(t: ModuleTemplate<mUE>): Module<mUE>

	@Suppress("FunctionName")
	@LowLevelApi
	public fun _finishSetup()

	@Suppress("PropertyName", "INAPPLICABLE_JVM_NAME")
	@LowLevelApi
	@get:JvmName("_getExecutor")
	public val _executor: Executor
}